## python-advanced-alchemy 0.29.1

=== Makefile ===
SHELL := /bin/bash

# =============================================================================
# Configuration and Environment Variables
# =============================================================================

.DEFAULT_GOAL:=help
.ONESHELL:
.EXPORT_ALL_VARIABLES:
MAKEFLAGS += --no-print-directory

# -----------------------------------------------------------------------------
# Display Formatting and Colors
# -----------------------------------------------------------------------------
BLUE := $(shell printf "\033[1;34m")
GREEN := $(shell printf "\033[1;32m")
RED := $(shell printf "\033[1;31m")
YELLOW := $(shell printf "\033[1;33m")
NC := $(shell printf "\033[0m")
INFO := $(shell printf "$(BLUE)ℹ$(NC)")
OK := $(shell printf "$(GREEN)✓$(NC)")
WARN := $(shell printf "$(YELLOW)⚠$(NC)")
ERROR := $(shell printf "$(RED)✖$(NC)")

# =============================================================================
# Help and Documentation
# =============================================================================

.PHONY: help
help:                                               ## Display this help text for Makefile
	@awk 'BEGIN {FS = ":.*##"; printf "\nUsage:\n  make \033[36m<target>\033[0m\n"} /^[a-zA-Z0-9_-]+:.*?##/ { printf "  \033[36m%-15s\033[0m %s\n", $$1, $$2 } /^##@/ { printf "\n\033[1m%s\033[0m\n", substr($$0, 5) } ' $(MAKEFILE_LIST)

# =============================================================================
# Installation and Environment Setup
# =============================================================================

.PHONY: install-uv
install-uv:                                         ## Install latest version of uv
	@echo "${INFO} Installing uv..."
	@curl -LsSf https://astral.sh/uv/install.sh | sh >/dev/null 2>&1
	@uv tool install nodeenv >/dev/null 2>&1
	@echo "${OK} UV installed successfully"

.PHONY: install
install: destroy clean                              ## Install the project, dependencies, and pre-commit
	@echo "${INFO} Starting fresh installation..."
	@uv python pin 3.12 >/dev/null 2>&1
	@uv venv >/dev/null 2>&1
	@uv sync --all-extras --dev
	@echo "${OK} Installation complete! 🎉"

.PHONY: destroy
destroy:                                            ## Destroy the virtual environment
	@echo "${INFO} Destroying virtual environment... 🗑️"
	@rm -rf .venv
	@echo "${OK} Virtual environment destroyed 🗑️"

# =============================================================================
# Dependency Management
# =============================================================================

.PHONY: upgrade
upgrade:                                            ## Upgrade all dependencies to latest stable versions
	@echo "${INFO} Updating all dependencies... 🔄"
	@uv lock --upgrade
	@echo "${OK} Dependencies updated 🔄"
	@uv run pre-commit autoupdate
	@echo "${OK} Updated Pre-commit hooks 🔄"

.PHONY: lock
lock:                                              ## Rebuild lockfiles from scratch
	@echo "${INFO} Rebuilding lockfiles... 🔄"
	@uv lock --upgrade >/dev/null 2>&1
	@echo "${OK} Lockfiles updated"

# =============================================================================
# Build and Release
# =============================================================================

.PHONY: build
build:                                             ## Build the package
	@echo "${INFO} Building package... 📦"
	@uv build >/dev/null 2>&1
	@echo "${OK} Package build complete"

.PHONY: release
release:                                           ## Bump version and create release tag
	@echo "${INFO} Preparing for release... 📦"
	@make docs
	@make clean
	@make build
	@uv lock --upgrade-package advanced-alchemy >/dev/null 2>&1
	@uv run bump-my-version bump $(bump)
	@echo "${OK} Release complete 🎉"

# =============================================================================
# Cleaning and Maintenance
# =============================================================================

.PHONY: clean
clean:                                              ## Cleanup temporary build artifacts
	@echo "${INFO} Cleaning working directory... 🧹"
	@rm -rf .pytest_cache .ruff_cache .hypothesis build/ dist/ .eggs/ .coverage coverage.xml coverage.json htmlcov/ .pytest_cache tests/.pytest_cache tests/**/.pytest_cache .mypy_cache .unasyncd_cache/ .auto_pytabs_cache node_modules >/dev/null 2>&1
	@find . -name '*.egg-info' -exec rm -rf {} + >/dev/null 2>&1
	@find . -type f -name '*.egg' -exec rm -f {} + >/dev/null 2>&1
	@find . -name '*.pyc' -exec rm -f {} + >/dev/null 2>&1
	@find . -name '*.pyo' -exec rm -f {} + >/dev/null 2>&1
	@find . -name '*~' -exec rm -f {} + >/dev/null 2>&1
	@find . -name '__pycache__' -exec rm -rf {} + >/dev/null 2>&1
	@find . -name '.ipynb_checkpoints' -exec rm -rf {} + >/dev/null 2>&1
	@echo "${OK} Working directory cleaned"
	$(MAKE) docs-clean

# =============================================================================
# Testing and Quality Checks
# =============================================================================

.PHONY: test
test:                                              ## Run the tests
	@echo "${INFO} Running test cases... 🧪"
	@uv run pytest -n 2 --quiet
	@echo "${OK} Tests passed ✨"

.PHONY: coverage
coverage:                                          ## Run tests with coverage report
	@echo "${INFO} Running tests with coverage... 📊"
	@uv run pytest --cov -n auto --quiet
	@uv run coverage html >/dev/null 2>&1
	@uv run coverage xml >/dev/null 2>&1
	@echo "${OK} Coverage report generated ✨"

# -----------------------------------------------------------------------------
# Type Checking
# -----------------------------------------------------------------------------

.PHONY: mypy
mypy:                                              ## Run mypy
	@echo "${INFO} Running mypy... 🔍"
	@uv run dmypy run
	@echo "${OK} Mypy checks passed ✨"

.PHONY: mypy-nocache
mypy-nocache:                                      ## Run Mypy without cache
	@echo "${INFO} Running mypy without cache... 🔍"
	@uv run mypy
	@echo "${OK} Mypy checks passed ✨"

.PHONY: pyright
pyright:                                           ## Run pyright
	@echo "${INFO} Running pyright... 🔍"
	@uv run pyright
	@echo "${OK} Pyright checks passed ✨"

.PHONY: type-check
type-check: mypy pyright                           ## Run all type checking

# -----------------------------------------------------------------------------
# Linting and Formatting
# -----------------------------------------------------------------------------

.PHONY: pre-commit
pre-commit:                                        ## Run pre-commit hooks
	@echo "${INFO} Running pre-commit checks... 🔎"
	@NODE_OPTIONS="--no-deprecation --disable-warning=ExperimentalWarning" uv run pre-commit run --color=always --all-files
	@echo "${OK} Pre-commit checks passed ✨"

.PHONY: slotscheck
slotscheck:                                        ## Run slotscheck
	@echo "${INFO} Running slots check... 🔍"
	@uv run slotscheck
	@echo "${OK} Slots check passed ✨"

.PHONY: fix
fix:                                               ## Run code formatters
	@echo "${INFO} Running code formatters... 🔧"
	@uv run ruff check --fix --unsafe-fixes
	@echo "${OK} Code formatting complete ✨"

.PHONY: lint
lint: pre-commit type-check slotscheck             ## Run all linting checks

.PHONY: check-all
check-all: lint test coverage                      ## Run all checks (lint, test, coverage)

# =============================================================================
# Documentation
# =============================================================================

.PHONY: docs-clean
docs-clean:                                        ## Clean documentation build
	@echo "${INFO} Cleaning documentation build assets... 🧹"
	@rm -rf docs/_build >/dev/null 2>&1
	@echo "${OK} Documentation assets cleaned"

.PHONY: docs-serve
docs-serve:                              ## Serve documentation locally
	@echo "${INFO} Starting documentation server... 📚"
	@uv run sphinx-autobuild docs docs/_build/ -j auto --watch advanced_alchemy --watch docs --watch tests --watch CONTRIBUTING.rst --open-browser

.PHONY: docs
docs: docs-clean                                   ## Build documentation
	@echo "${INFO} Building documentation... 📝"
	@uv run sphinx-build -M html docs docs/_build/ -E -a -j auto -W --keep-going
	@echo "${OK} Documentation built successfully"

.PHONY: docs-linkcheck
docs-linkcheck:                                    ## Check documentation links
	@echo "${INFO} Checking documentation links... 🔗"
	@uv run sphinx-build -b linkcheck ./docs ./docs/_build -D linkcheck_ignore='http://.*','https://.*'
	@echo "${OK} Link check complete"

.PHONY: docs-linkcheck-full
docs-linkcheck-full:                               ## Run full documentation link check
	@echo "${INFO} Running full link check... 🔗"
	@uv run sphinx-build -b linkcheck ./docs ./docs/_build -D linkcheck_anchors=0
	@echo "${OK} Full link check complete"

=== debian/changelog ===
python-advanced-alchemy (0.29.1-1) unstable; urgency=medium

  * [f8eefee] New upstream version 0.29.1

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sat, 18 Jan 2025 07:31:59 +0200

python-advanced-alchemy (0.26.2-1) unstable; urgency=medium

  * [a3ec533] New upstream version 0.26.2
  * [5ea43d2] First and basic Debianization
    (Closes: #1092143)

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sat, 11 Jan 2025 08:03:05 +0200

## python-advanced-alchemy 0.30.2

=== debian/changelog ===
python-advanced-alchemy (0.30.2-1) unstable; urgency=medium

  * [8876256] New upstream version 0.30.2

 -- Carsten Schoenert <c.schoenert@t-online.de>  Wed, 22 Jan 2025 18:45:59 +0200

## python-advanced-alchemy 0.30.3

=== debian/changelog ===
python-advanced-alchemy (0.30.3-1) unstable; urgency=medium

  * [1637a56] New upstream version 0.30.3

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 16 Feb 2025 12:47:18 +0200

## python-advanced-alchemy 0.31.0

=== Makefile ===
--- 
+++ 
@@ -44,7 +44,7 @@
 .PHONY: install
 install: destroy clean                              ## Install the project, dependencies, and pre-commit
 	@echo "${INFO} Starting fresh installation..."
-	@uv python pin 3.12 >/dev/null 2>&1
+	@uv python pin 3.9 >/dev/null 2>&1
 	@uv venv >/dev/null 2>&1
 	@uv sync --all-extras --dev
 	@echo "${OK} Installation complete! 🎉"

=== debian/changelog ===
python-advanced-alchemy (0.31.0-1) unstable; urgency=medium

  * [24c4680] New upstream version 0.31.0

 -- Carsten Schoenert <c.schoenert@t-online.de>  Thu, 20 Feb 2025 16:16:53 +0200

=== debian/control ===
Source: python-advanced-alchemy
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders:
 Carsten Schoenert <c.schoenert@t-online.de>
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 pybuild-plugin-pyproject,
 python3-all,
 python3-hatchling,
# python3-asyncmy <!nocheck>,
## python3-asyncpg <!nocheck>,
# python3-pytest <!nocheck>,
## sqlalchemy-cockroachdb <!nocheck>,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/litestar-org/advanced-alchemy
Vcs-Git: https://salsa.debian.org/python-team/packages/python-advanced-alchemy.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/python-advanced-alchemy
Testsuite: autopkgtest-pkg-pybuild

Package: python3-advanced-alchemy
Architecture: all
Depends:
 ${misc:Depends},
 ${python3:Depends},
Description: Carefully crafted, tested, optimized companion library for SQLAlchemy (Python 3)
 Advanced Alchemy is offering useful and easy-to-use features for your database
 projects. It is built on:
 .
  * SQLAlchemy
  * msgspec
  * Alembic
  * Typing Extensions
 .
 This package contains the Python 3 version.

## python-advanced-alchemy 0.32.2

=== debian/changelog ===
python-advanced-alchemy (0.32.2-1) unstable; urgency=medium

  * [4de9f20] New upstream version 0.32.2

 -- Carsten Schoenert <c.schoenert@t-online.de>  Thu, 27 Feb 2025 17:18:54 +0200

## python-advanced-alchemy 0.34.0

=== debian/changelog ===
python-advanced-alchemy (0.34.0-1) unstable; urgency=medium

  * [95cbaf2] New upstream version 0.34.0
  * [b45c323] d/control: Bump Standards-Version to 4.7.2
    No further changes needed.

 -- Carsten Schoenert <c.schoenert@t-online.de>  Wed, 12 Mar 2025 17:53:43 +0200

## python-advanced-alchemy 1.0.1

=== debian/changelog ===
python-advanced-alchemy (1.0.1-1) unstable; urgency=medium

  * [9449557] New upstream version 1.0.1

 -- Carsten Schoenert <c.schoenert@t-online.de>  Thu, 20 Mar 2025 17:10:52 +0200

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
 ## python3-asyncpg <!nocheck>,
 # python3-pytest <!nocheck>,
 ## sqlalchemy-cockroachdb <!nocheck>,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/litestar-org/advanced-alchemy
 Vcs-Git: https://salsa.debian.org/python-team/packages/python-advanced-alchemy.git

## python-advanced-alchemy 1.1.1

=== debian/changelog ===
python-advanced-alchemy (1.1.1-1) unstable; urgency=medium

  * [85bb3ca] New upstream version 1.1.1

 -- Carsten Schoenert <c.schoenert@t-online.de>  Mon, 07 Apr 2025 17:16:41 +0200

python-advanced-alchemy (1.0.2-1) unstable; urgency=medium

  * [a76d851] New upstream version 1.0.2

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 06 Apr 2025 22:16:17 +0200

## python-advanced-alchemy 1.3.0

=== debian/changelog ===
python-advanced-alchemy (1.3.0-1) unstable; urgency=medium

  * [02f6dcc] New upstream version 1.3.0

 -- Carsten Schoenert <c.schoenert@t-online.de>  Mon, 21 Apr 2025 12:55:12 +0200

## python-advanced-alchemy 1.4.1

=== Makefile ===
--- 
+++ 
@@ -89,8 +89,8 @@
 	@make docs
 	@make clean
 	@make build
-	@uv lock --upgrade-package advanced-alchemy >/dev/null 2>&1
 	@uv run bump-my-version bump $(bump)
+	@uv lock --upgrade-package advanced-alchemy
 	@echo "${OK} Release complete 🎉"
 
 # =============================================================================

=== debian/changelog ===
python-advanced-alchemy (1.4.1-1) unstable; urgency=medium

  * [2812fe4] New upstream version 1.4.1

 -- Carsten Schoenert <c.schoenert@t-online.de>  Thu, 01 May 2025 13:36:54 +0200

=== debian/watch ===
version=4

opts="mode=git, \
      compression=gz, \
      pgpmode=none, \
      dversionmangle=s/\+ds(\.?\d+)?$//, \
      uversionmangle=s/(\d)[_\.\-\+]?((a|alpha|b|beta|dev|pre|RC|rc)\.?\d*)$/$1~$2/" \
https://github.com/litestar-org/advanced-alchemy.git \
      refs/tags/v?(\d\S+)

## python-advanced-alchemy 1.6.2

=== Makefile ===
--- 
+++ 
@@ -88,6 +88,7 @@
 	@echo "${INFO} Preparing for release... 📦"
 	@make docs
 	@make clean
+	@uv run python tools/pypi_readme.py
 	@make build
 	@uv run bump-my-version bump $(bump)
 	@uv lock --upgrade-package advanced-alchemy
@@ -118,15 +119,14 @@
 .PHONY: test
 test:                                              ## Run the tests
 	@echo "${INFO} Running test cases... 🧪"
-	@uv run pytest -n 2 --quiet
+	@uv run pytest --dist "loadgroup" -m "" tests -n 2 --quiet
 	@echo "${OK} Tests passed ✨"
 
 .PHONY: coverage
 coverage:                                          ## Run tests with coverage report
 	@echo "${INFO} Running tests with coverage... 📊"
-	@uv run pytest --cov -n auto --quiet
+	@uv run pytest tests --dist "loadgroup" -m "" --cov=advanced_alchemy --cov-report=xml -n 2 --quiet
 	@uv run coverage html >/dev/null 2>&1
-	@uv run coverage xml >/dev/null 2>&1
 	@echo "${OK} Coverage report generated ✨"
 
 # -----------------------------------------------------------------------------

=== debian/changelog ===
python-advanced-alchemy (1.6.2-1) unstable; urgency=medium

  * [6c41612] d/watch: Convert to version 5
  * [6cc09e7] New upstream version 1.6.2
  * [26bebd8] d/control: Remove Rules-Requires-Root
    The setting of Rules-Requires-Root: no is now default.

 -- Carsten Schoenert <c.schoenert@t-online.de>  Thu, 18 Sep 2025 17:39:20 +0200

## python-advanced-alchemy 1.7.0

=== debian/changelog ===
python-advanced-alchemy (1.7.0-1) unstable; urgency=medium

  * [7f06f96] New upstream version 1.7.0

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sat, 25 Oct 2025 09:00:15 +0200

## python-advanced-alchemy 1.8.0

=== debian/changelog ===
python-advanced-alchemy (1.8.0-1) unstable; urgency=medium

  * [c399082] New upstream version 1.8.0

 -- Carsten Schoenert <c.schoenert@t-online.de>  Wed, 29 Oct 2025 07:13:14 +0200

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,6 @@
 # python3-pytest <!nocheck>,
 ## sqlalchemy-cockroachdb <!nocheck>,
 Standards-Version: 4.7.2
-Rules-Requires-Root: no
 Homepage: https://github.com/litestar-org/advanced-alchemy
 Vcs-Git: https://salsa.debian.org/python-team/packages/python-advanced-alchemy.git
 Vcs-Browser: https://salsa.debian.org/python-team/packages/python-advanced-alchemy

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

export PYBUILD_NAME=advanced_alchemy
# Tests using a docker container pulled from the internet.
# Not what we want to have nor can deal with.
export PYBUILD_DISABLE=test

%:
	dh $@ --buildsystem=pybuild

override_dh_clean:
	rm -rf .mypy_cache
	dh_clean

=== debian/watch ===
Version: 5

Source: https://github.com/litestar-org/advanced-alchemy.git
Matching-Pattern: refs/tags/v?(\d\S+)
Compression: gz
Dversionmangle: s/\+ds(\.?\d+)?$//
Uversionmangle: s/(\d)[_\.\-\+]?((a|alpha|b|beta|dev|pre|RC|rc)\.?\d*)$/$1~$2/
Mode: git
Pgpmode: none

## python-advanced-alchemy 1.8.2

=== Makefile ===
--- 
+++ 
@@ -44,7 +44,7 @@
 .PHONY: install
 install: destroy clean                              ## Install the project, dependencies, and pre-commit
 	@echo "${INFO} Starting fresh installation..."
-	@uv python pin 3.9 >/dev/null 2>&1
+	@uv python pin 3.10 >/dev/null 2>&1
 	@uv venv >/dev/null 2>&1
 	@uv sync --all-extras --dev
 	@echo "${OK} Installation complete! 🎉"

=== debian/changelog ===
python-advanced-alchemy (1.8.2-1) unstable; urgency=medium

  * [42cc55b] New upstream version 1.8.2
  * [4dba8b7] d/control: Bump Standards-Version to 4.7.3
    No further changes needed.
  * [524e781] d/u/metadata: Update Documentation field

 -- Carsten Schoenert <c.schoenert@t-online.de>  Wed, 24 Dec 2025 12:00:45 +0200

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
 ## python3-asyncpg <!nocheck>,
 # python3-pytest <!nocheck>,
 ## sqlalchemy-cockroachdb <!nocheck>,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://github.com/litestar-org/advanced-alchemy
 Vcs-Git: https://salsa.debian.org/python-team/packages/python-advanced-alchemy.git
 Vcs-Browser: https://salsa.debian.org/python-team/packages/python-advanced-alchemy
